diff --git a/core/java/android/os/IAquiferService.aidl b/core/java/android/os/IAquiferService.aidl
new file mode 100644
index 0000000..d7433e9
--- /dev/null
+++ b/core/java/android/os/IAquiferService.aidl
@@ -0,0 +1,50 @@
+package android.os;
+import android.os.AquiferList;
+import android.os.Policy;
+/**The AquiferService aidl.
+ * Author: Adwait Nadkarni
+ */
+interface IAquiferService
+{	
+	//Test Functions
+	String hi(int val);	
+//	String message(String val);
+
+	//Management Functions:
+	void addParticipant(String sprocessName, int spid, String rprocessName, int rpid, String rpackageName, int ruid, int resultcode, String componentName);
+	
+	//Utility Functions
+	String getProcessName(int pid);
+	
+	//Getting the principals list for a certain action         
+	AquiferList getPrincipalList(String sprocessName, int spid, String action);
+
+	//Adding Policy
+	void addPolicy(in Policy p);
+
+	//intercepting a databaseupdate
+	//void interceptDatabase();
+
+	//Managing the workflow when an activity is destroyed
+	void destroyActivity(String componentName);
+
+	//Adding a component to an existing participant
+	void addComponent( String sprocessName, int spid, String spackageName, int suid, int resultcode ,String rcomponentName);
+
+	//Join two workflows, and assign the join to the receiving workflow.
+	void workflowJoin(String sprocessName, int spid, String rprocessName, int rpid, String rpackageName, int ruid, int resultcode, String rcomponentName);
+	
+	//Verify if the process rprocessname is in the workflow of sprocessName
+	boolean isThisWorkflow(String sprocessName, int spid, String rprocessName, int rpid);
+
+	//Destroy a process to start a new one
+	void destroyEntireProcess(String processName, int pid);
+
+	//Storing packageName:uid mappings with the AquiferService on install
+	int storePackageName(String packageName, int uid);
+
+	//Removing packageName from the AquiferService on uninstall
+	int removePackageName(String packageName);
+
+}
+
diff --git a/core/java/android/os/Participant.aidl b/core/java/android/os/Participant.aidl
new file mode 100644
index 0000000..7b35e65
--- /dev/null
+++ b/core/java/android/os/Participant.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable Participant;
diff --git a/core/java/android/os/Participant.java b/core/java/android/os/Participant.java
new file mode 100644
index 0000000..51ef715
--- /dev/null
+++ b/core/java/android/os/Participant.java
@@ -0,0 +1,128 @@
+/* Participant Class.
+ * Defines a workflow Participant(processName, packageName, pid, uid, resultcode)
+ * Author: Adwait Nadkarni
+ */
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.ListIterator;
+import android.os.ComponentScreen;
+//to be used as both lists and pos and neg capabilities
+//since we have separated the pos and neg capabilities into 2 lists
+//this becomes easy.
+public class Participant implements Parcelable
+{	
+        String processName;
+        String packageName;
+        int pid;
+        int uid;
+        int resultcode;
+	ArrayList<ComponentScreen> componentList;
+	public static final Parcelable.Creator<Participant> CREATOR = new
+        Parcelable.Creator<Participant>() {
+                public Participant createFromParcel(Parcel in) {
+                         return new Participant(in);
+                }
+                 public Participant[] newArray(int size) {
+                        return new Participant[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private Participant(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+                out.writeString(processName);
+                out.writeString(packageName);
+		out.writeInt(pid);
+		out.writeInt(uid);
+		out.writeInt(resultcode);
+		out.writeList(componentList);
+        }
+
+        public void readFromParcel(Parcel in) {
+		processName=in.readString();
+		packageName=in.readString();
+		pid=in.readInt();
+		uid=in.readInt();
+		resultcode=in.readInt();
+		in.readList(componentList, ComponentScreen.class.getClassLoader());
+        }
+
+	//Constructor
+	public Participant(String processName, String packageName, int pid, int uid, int resultcode, ArrayList<ComponentScreen> componentList)
+        {
+                this.processName=processName;
+                this.packageName=packageName;
+                this.pid=pid;
+                this.uid=uid;
+                this.resultcode=resultcode;
+		this.componentList=componentList;
+        }
+                
+	//Getters
+        public String getProcessName()
+        {
+                return this.processName;
+        }
+        public String getPackageName()
+        {
+                return this.packageName;
+        }
+        public int getPid()
+        {
+                return this.pid;
+        }
+        public int getUid()
+        {
+                return this.uid;
+        }
+        public int getResultCode()
+        {
+                return this.resultcode;
+        }
+	public boolean isComponentEmpty()
+	{
+		return componentList.isEmpty();
+	}
+	public void removeComponent(String componentName)
+	{
+		//Removing the matching component with the latest timestamp
+		Iterator<ComponentScreen> iterator = componentList.iterator();
+		long timestamp=0;
+		int index=0;
+		while(iterator.hasNext())
+		{
+			ComponentScreen current = iterator.next();
+			if(current.getComponentName().equals(componentName))
+			{
+				if(current.getTimeStamp() >= timestamp)
+				{
+					timestamp = current.getTimeStamp();
+					index = componentList.indexOf(current);
+				}	
+			}
+		}
+		componentList.remove(index);
+	}
+	public void addComponent(String componentName, int resultcode)
+	{
+		componentList.add(new ComponentScreen(componentName, resultcode, System.currentTimeMillis()));
+	}
+	public ArrayList<ComponentScreen> getComponentList()
+	{
+		return componentList;
+	}
+	// Participant Display Method
+	public void displayParticipant()
+	{	
+		System.out.println("Participant:");
+		System.out.println("process:"+processName+":"+pid+"|package"+packageName+":"+uid+"|resultcode="+resultcode);
+	}
+}	
diff --git a/core/java/android/os/Policy.aidl b/core/java/android/os/Policy.aidl
new file mode 100644
index 0000000..d5fdb48
--- /dev/null
+++ b/core/java/android/os/Policy.aidl
@@ -0,0 +1,3 @@
+package android.os;
+
+parcelable Policy;
diff --git a/core/java/android/os/Policy.java b/core/java/android/os/Policy.java
new file mode 100644
index 0000000..c5f5cd5
--- /dev/null
+++ b/core/java/android/os/Policy.java
@@ -0,0 +1,137 @@
+/* Aquifer Policy Class.
+ * Defines Policy{Enforcement, Filter}
+ * Author: Adwait Nadkarni
+*/
+
+package android.os;
+import android.os.Parcel;
+import android.os.Parcelable;
+import android.os.AquiferList;
+//import android.os.Enforcement;
+import android.os.Filter;
+import java.util.ListIterator;
+import java.io.Serializable;
+
+public class Policy implements Parcelable, Serializable
+{	
+	private AquiferList ExportList;
+	private AquiferList RequiredList;
+//	private Enforcement enforcement;
+	private Filter filter;
+	public static final Parcelable.Creator<Policy> CREATOR = new
+        Parcelable.Creator<Policy>() {
+                public Policy createFromParcel(Parcel in) {
+                         return new Policy(in);
+                }
+                 public Policy[] newArray(int size) {
+                        return new Policy[size];
+                }
+        };
+        //constructor to set the tagName in case we need to;
+        private Policy(Parcel in) {
+                readFromParcel(in);
+        }
+	public int describeContents()
+	{
+		return 0;
+	}
+        public void writeToParcel(Parcel out, int flags) {
+  //              out.writeParcelable(enforcement,flags);
+                out.writeParcelable(ExportList,flags);
+                out.writeParcelable(RequiredList,flags);
+                out.writeParcelable(filter,flags);
+        }
+
+        public void readFromParcel(Parcel in) {
+//               	 enforcement = in.readParcelable(Enforcement.class.getClassLoader());
+               	 ExportList = in.readParcelable(AquiferList.class.getClassLoader());
+               	 RequiredList = in.readParcelable(AquiferList.class.getClassLoader());
+               	 filter = in.readParcelable(Filter.class.getClassLoader());
+        }
+
+	//Constructors	
+	public Policy()
+	{
+//		enforcement = new Enforcement();
+	        ExportList = new AquiferList();
+		RequiredList = new AquiferList();
+		RequiredList.setEmpty();	
+		filter = new Filter();
+	}
+	public Policy(Policy policy)
+	{
+//		this.enforcement = policy.enforcement;
+		this.filter = policy.filter;
+		this.ExportList = policy.ExportList;
+		this.RequiredList = policy.RequiredList;
+	}
+
+	//Getters and Setters
+/*	public Enforcement getEnforcement()
+	{
+		return this.enforcement;
+	}
+	public void setEnforcement(Enforcement enforcement)
+	{
+		this.enforcement = enforcement;
+	}
+*/	//
+	public Filter getFilter()
+	{
+		return this.filter;
+	}
+	public void setFilter(Filter filter)
+	{
+		this.filter = filter;
+	}
+	//
+	public AquiferList getExportList()
+	{
+		return this.ExportList;
+	}
+	public void setExportList(AquiferList export)
+	{
+		this.ExportList = export;
+	}
+	//
+	public AquiferList getRequiredList()
+	{
+		return this.RequiredList;
+	}
+	public void setRequiredList( AquiferList required)
+	{
+		this.RequiredList = required;
+	}
+
+	//Policy Display Method
+	public void displayPolicy()
+	{	
+		System.out.println("Policy:");
+//		enforcement.displayEnforcement();
+		System.out.println("Export List:");
+		ExportList.displayAquiferList();
+		System.out.println("Required List:");
+		RequiredList.displayAquiferList();
+		filter.displayFilter();
+	}	
+
+	//Policy Join
+	public static Policy policyJoin(Policy policy1, Policy policy2)
+	{
+		if(policy1 == null)
+			return policy2;
+		else if(policy2==null)
+			return policy1;
+		else{
+			Policy policy3 = new Policy();
+//			policy3.setEnforcement(Enforcement.enforcementJoin(policy1.getEnforcement(), policy2.getEnforcement()));
+			policy3.setFilter(Filter.filterJoin(policy1.getFilter(), policy2.getFilter()));			
+			policy3.ExportList = AquiferList.listIntersection(policy1.getExportList(), policy2.getExportList());
+                	policy3.RequiredList = AquiferList.listUnion(policy1.getRequiredList(), policy2.getRequiredList());
+		
+			return policy3;
+		}
+	
+	}
+
+}	
diff --git a/core/java/android/os/Process.java b/core/java/android/os/Process.java
index e1bc275..9514d1a 100644
--- a/core/java/android/os/Process.java
+++ b/core/java/android/os/Process.java
@@ -16,6 +16,7 @@
 
 package android.os;
 
+import android.os.IAquiferService;
 import android.net.LocalSocketAddress;
 import android.net.LocalSocket;
 import android.util.Log;
@@ -722,7 +723,23 @@ public class Process {
      * other's processes.
      */
     public static final void killProcess(int pid) {
+	//Adwait's patch	
+	String processName="initial";
+	IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try{
+       		processName=aquifer.getProcessName(pid);
+        }
+        catch(Exception e)
+        {
+		System.out.println("Exception at android.os.Proceess:killProcess");
+	}
+	System.out.println("Killing process "+processName+":"+pid);
+	//Adwait's patch ends
+	//get procname:pid here
         sendSignal(pid, SIGNAL_KILL);
+	//get procname:pid here. If same obtained, then
+	//the process has been killed; so now remove it from the
+	//workflow
     }
 
     /** @hide */
@@ -746,6 +763,17 @@ public class Process {
      * beat you up.
      */
     public static final void killProcessQuiet(int pid) {
+	//Adwait's patch        
+        String processName="initial";
+        IAquiferService aquifer = IAquiferService.Stub.asInterface(ServiceManager.getService("Aquifer"));
+        try{   
+                processName=aquifer.getProcessName(pid);
+        }
+        catch(Exception e)
+        {
+                System.out.println("Exception at android.os.Proceess:killProcess");
+        }
+        System.out.println("Killing process "+processName+":"+pid);
         sendSignalQuiet(pid, SIGNAL_KILL);
     }
 
diff --git a/services/audioflinger/Android.mk b/services/audioflinger/Android.mk
index fa49592..122ca32 100644
--- a/services/audioflinger/Android.mk
+++ b/services/audioflinger/Android.mk
@@ -22,7 +22,7 @@ LOCAL_SHARED_LIBRARIES := \
     libhardware_legacy \
     libeffects \
     libdl \
-    libpowermanager
+    libpowermanager \
 
 LOCAL_STATIC_LIBRARIES := \
     libcpustats \
